/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 一括登録初期表示アクションクラス
// 
//
//	変更履歴
//		2004.01.08 新規作成 T.Nishiki 
//
package jp.co.ntt.lms.xms.lumpfile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.xmo.Mail.MailConst;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsWarningException;
import jp.co.ntt.lms.xms.common.util.CommonUtil;
import jp.co.ntt.lms.xms.common.util.StringUtil;

/**
 * 一括登録初期表示アクションクラス。
 * @author T.Nishiki
 */
public class LumpFileFirstAction extends XmsBusinessAction {

	/**
	 * リクエスト処理初期化メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void initProcessRequest(XmsRequest xmsRequest)
		throws XmsException {
	}

	/**
	 * リクエスト処理メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {
		LumpFileParameterBean bean = null;
		try {
			// セッションのクリア
			clearSession(xmsRequest);
			// パラメータBeanの生成
			bean = createBean(xmsRequest);
			// 呼び出しもとのＵＲＬをセッションに格納
			setBaseReloadUrl(xmsRequest);
			// Beanの設定
			xmsResponse.setBusinessBean(bean);
			// メールテンプレートに対する設定
			setInformationForTemplate(xmsRequest);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}


	/**
	 * 初期表示にあたり、あらかじめセッションの内容をクリアする。<br>
	 * @param xmsRequest リクエスト・オブジェクト。
	 */
	private void clearSession(XmsRequest xmsRequest) throws XmsException {

		try {
			// セッション情報の削除
			CommonUtil.removeSessionData(
				xmsRequest,
				LumpFileConstant.KEYS_SESSION);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}

	/**
	 * リクエストパラメータから、LumpFileParameterBeanを生成する。
	 * @param xmsRequest リクエスト・オブジェクト。
	 * @param xmsResponse
	 * @return 生成したオブジェクト。
	 * @throws XmsException パラメータに不足がある場合。
	 */
	private LumpFileParameterBean createBean(XmsRequest xmsRequest)
		throws XmsException {
		// 登録先グループＩＤ
		String parentID = null;

		// このメソッドの戻り値
		LumpFileParameterBean bean = null;

		try {
			bean = new LumpFileParameterBean();

			// パラメータの取得
			parentID =
				xmsRequest.getParameter(LumpFileConstant.NAME_PARENT_ID);

			// パラメータのチェック
			if ( StringUtil.isNullString(parentID) == true ) {
				throw new XmsWarningException(LumpFileConstant.KEY_MESSAGE_INVALID_PARAMETER);
			}
			// beanに設定
			bean.setParentID(parentID);

		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
		return bean;
	}

	/**
	 * メールテンプレート用に情報を設定する。<br>
	 * 
	 * @param xmsRequest リクエスト・オブジェクト。
	 * @throws XmsException 処理中に例外が発生した場合。
	 */
	private void setInformationForTemplate(XmsRequest xmsRequest)
		throws XmsException {

		// HTTPリクエスト。
		HttpServletRequest request = null;
		// HTTセッション。
		HttpSession session = null;

		try {
			request = xmsRequest.getRequest();
			session = request.getSession(false);

			// メール種別を設定
			if (session != null) {
				session.setAttribute(
					LumpFileConstant.KEY_MAIL_TYPE,
					MailConst.TYPE_LUMP);
			}
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}

	/**
	 * このアクションを呼び出しもとなる画面にリロードするＵＲＬをセッションに登録する。<br>
	 * @param xmsRequest リクエスト・オブジェクト。
	 */
	private void setBaseReloadUrl(XmsRequest xmsRequest) 
			throws XmsException {
		// HTTPリクエスト。
		HttpServletRequest request = null;
		// HTTセッション。
		HttpSession session = null;
		// 基本画面ＵＲＬ
		String baseReloadURL = null;
		try {
			// 基本画面ＵＲＬを取得
			baseReloadURL = xmsRequest.getParameter(LumpFileConstant.NAME_BASE_RELOAD_URL);
			if ( StringUtil.isNullString(baseReloadURL) == true ) {
				DebugLog.write( this.getClass(), LumpFileConstant.KEY_BASE_RELOAD_URL + "is null", DebugLog.HIGHT);
				throw new XmsWarningException( LumpFileConstant.KEY_MESSAGE_INVALID_PARAMETER );
			}
			// セッションの取得
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			// 基本画面ＵＲＬをセッションに登録
			if (session != null) {
				session.setAttribute(LumpFileConstant.KEY_BASE_RELOAD_URL, baseReloadURL);
			}
		} catch (XmsWarningException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}

}
